<template>
  <q-page padding>
    <!-- content -->

    <!-- listado -->
    <div v-if="view === 'list'">
      <div class="q-pa-md">
        <q-table title="Productos" :rows="rows" :columns="columns" row-key="name" :no-data-label="'Sin datos'"
          :loading-label="'Cargando...'" :loading="loading" color="primary" :pagination="pagination" :grid="grid">

          <template v-slot:top-right>
            <div class="row">
              <div class="col-7">
                <q-input dense debounce="300" v-model="filter" placeholder="Buscar..."
                  @update:model-value="val => onRequest({ filter: val })">
                  <template v-slot:append>
                    <q-icon name="search" />
                  </template>
                </q-input>
              </div>
              <div class="col-3">
                <q-btn icon="add" color="primary" @click="addProducto()" dense round flat>
                  <q-tooltip>Agregar</q-tooltip>
                </q-btn>
              </div>
              <div class="col-2">
                <q-toggle v-model="grid" color="primary" />
              </div>
            </div>
          </template>

          <template v-if="grid" v-slot:item="props">

            <div class="q-pa-xs col-xs-12 col-sm-6 col-md-4 col-lg-3">
              <q-card>

                <q-item>
                  <q-img class="img-border rounded-borders"
                    src="https://visuar.com.py/18544-large_default/smart-tv-samsung-55-crystal-uhd-4k-tu7090-.jpg"
                    height="150px">
                  </q-img>
                </q-item>

                <div class="row q-pa-md">
                  <div class="col-6 q-pa-xs"
                    v-for="col in props.cols.filter(x => !['acciones', 'imagen'].includes(x.name))" :key="col.name">
                    <q-item-section>
                      <q-item-label caption>
                        {{ col.label }}
                      </q-item-label>
                      <q-item-label>
                        {{ col.value }}
                      </q-item-label>
                    </q-item-section>
                  </div>
                </div>

                <div class="q-pa-md">
                  <q-rating v-model="props.row.ranking" max="5" size="3em" color="primary" icon="star_border"
                    icon-selected="star" icon-half="star_half" no-dimming />
                </div>

                <q-separator />
                <q-card-actions align="around">
                  <q-btn icon="edit" color="primary" @click="editProducto(props.row)" dense round flat>
                    <q-tooltip>Editar</q-tooltip>
                  </q-btn>
                  <q-btn icon="delete" color="negative" @click="deleteProducto(props.row)" dense round flat>
                    <q-tooltip>Eliminar</q-tooltip>
                  </q-btn>
                </q-card-actions>

              </q-card>
            </div>
          </template>

          <template v-else v-slot:body="props">
            <q-tr :props="props">
              <q-td v-for="col in props.cols" :key="col.name" :props="props">

                <template v-if="col.name === 'acciones'">
                  <q-btn icon="edit" color="primary" @click="editProducto(props.row)" dense round flat>
                    <q-tooltip>Editar</q-tooltip>
                  </q-btn>
                  <q-btn icon="delete" color="negative" @click="deleteProducto(props.row)" dense round flat>
                    <q-tooltip>Eliminar</q-tooltip>
                  </q-btn>
                </template>

                <template v-else-if="col.name === 'imagen'">
                  <q-img
                    src="https://visuar.com.py/18545-large_default/smart-tv-samsung-50-crystal-uhd-4k-2020-tu7090.jpg"></q-img>
                </template>

                <template v-else> {{ col.value }} </template>
              </q-td>
            </q-tr>
          </template>

        </q-table>
      </div>
    </div>

    <!-- add/edit -->
    <div v-if="view === 'add' || view === 'edit'">
      <q-form @submit="submitProducto()">
        <q-card bordered>


          <q-card-section>
            <div class="text-h6">Agregar Producto</div>
            <div class="text-subtitle2">Complete los datos solicitados</div>
          </q-card-section>

          <q-card-section class="flex flex-center">
            <q-card flat bordered v-bind:style="{ 'min-width': '80%' }">
              <q-card-section>

                <div class="row">
                  <div class="col-6">
                    <q-select v-model="producto.proveedor_id" :options="proveedorList" label="Proveedor"
                      option-label="nombre" option-value="id" map-options emit-value />
                  </div>
                  <div class="col-6 q-pl-sm">
                    <q-select v-model="producto.categoria_id" :options="categoriaList" label="Categoria"
                      option-label="descripcion" option-value="id" map-options emit-value />
                  </div>
                </div>

                <div class="row">
                  <div class="col-12">
                    <q-input v-model="producto.nombre" label="Nombre" dense></q-input>
                  </div>
                </div>

                <div class="row">
                  <div class="col-12">
                    <q-input v-model="producto.descripcion" label="Descripcion" dense></q-input>
                  </div>
                </div>

                <div class="row">
                  <div class="col-12">
                    <q-input v-model.number="producto.precio" label="Precio" type="number" dense></q-input>
                  </div>
                </div>

                <div class="row">
                  <div class="col-12">
                    <q-input v-model="producto.estado" label="Estado" dense></q-input>
                  </div>
                </div>

              </q-card-section>
            </q-card>
          </q-card-section>

          <q-separator />

          <q-card-actions align="around">
            <q-btn flat color="primary" type="submit" :loading="loading">Grabar</q-btn>
            <q-btn flat @click="onCancel">Cancelar</q-btn>
          </q-card-actions>

        </q-card>
      </q-form>
    </div>

  </q-page>
</template>

<script>
import axios from 'axios'
import { onMounted, ref } from 'vue'
import { useQuasar } from 'quasar'

export default {
  // name: 'PageName',
  setup() {
    // Propiedades
    const $q = useQuasar()
    const columns = [
      { name: 'imagen', align: 'center', label: 'Imagen', field: row => row.imagen, sortable: true },
      { name: 'nombre', align: 'left', label: 'Nombre', field: row => row.nombre, sortable: true },
      { name: 'descripcion', align: 'left', label: 'Descripcion', field: row => row.descripcion, sortable: true },
      { name: 'precio', align: 'left', label: 'Precio', field: row => row.precio, sortable: true },
      { name: 'estado', align: 'left', label: 'Estado', field: row => row.estado, sortable: true },
      { name: 'proveedor', align: 'left', label: 'Proveedor', field: row => row._proveedor?.nombre, sortable: true },
      { name: 'categoria', align: 'left', label: 'Categoria', field: row => row._categoria?.descripcion, sortable: true },
      { name: 'acciones', align: 'center', label: 'Acciones' }
    ]
    const rows = ref([])
    const view = ref('list')  //list, add, edit
    const filter = ref(null)
    const loading = ref(false)
    const producto = ref({})
    const pagination = ref({
      sortBy: '',
      descending: true,
      page: 1,
      rowsPerPage: 0
    })
    const proveedorList = ref([])
    const categoriaList = ref([])
    const grid = ref(true)


    // Metodos
    const onRequest = (props) => {
      console.log(props)
      loading.value = true
      const url = 'http://localhost:5000/api/search/productos'
      const filtros = {
        nombre: props.filter
      }
      axios.post(url, filtros).then(res => {
        // obtener la lista de productos y asignar al lista para el template
        console.log(res.data.items)
        rows.value = res.data.items

      }).catch(error => {
        // emitir un mensaje
      }).finally(() => {
        // Acciones finales
        loading.value = false
      })
    }

    const clearProducto = () => {
      return {
        id: null,
        proveedor_id: null,
        categoria_id: null,
        nombre: null,
        descripcion: null,
        precio: null,
        estado: null
      }
    }

    const addProducto = () => {
      view.value = 'add'
      producto.value = clearProducto()
    }

    const editProducto = (instance) => {
      view.value = 'edit'
      producto.value = instance
    }

    const onCancel = () => {
      view.value = 'list'
      producto.value = clearProducto()
    }

    const submitProducto = () => {
      console.log(producto.value)
      loading.value = true

      if (producto.value.id) {  // Editar
        const url = `http://localhost:5000/api/productos/${producto.value.id}`
        axios.put(url, producto.value).then(res => {
          // notificar exito
          $q.notify({
            message: 'Producto Modificado',
            color: 'positive'
          })
          // redirigir a la vista de listado
          view.value = 'list'
          // actualizar el listado
          onRequest({
            filter: null
          })
        }).catch(error => {
          // notificar el error
          console.log(error)
          let msg = 'Producto No Modificado'
          try {
            msg = error.response.data.message
          } catch (error) {
            console.log(error)
          }
          $q.notify({
            message: msg,
            color: 'negative'
          })
        }).finally(() => {
          // acciones finales
          loading.value = false
        })
      } else {  // Agregar
        const url = 'http://localhost:5000/api/productos'
        axios.post(url, producto.value).then(res => {
          // notificar exito
          $q.notify({
            message: 'Producto Agregado',
            color: 'positive'
          })
          // redirigir a la vista de listado
          view.value = 'list'
          // actualizar el listado
          onRequest({
            filter: null
          })
        }).catch(error => {
          // notificar el error
          console.log(error)
          let msg = 'Producto No Agregado'
          try {
            msg = error.response.data.message
          } catch (error) {
            console.log(error)
          }
          $q.notify({
            message: msg,
            color: 'negative'
          })
        }).finally(() => {
          // acciones finales
          loading.value = false
        })
      }
    }

    const deleteProducto = (instance) => {
      $q.dialog({
        title: 'Eliminar Producto',
        message: `Esta seguro de que desea eliminar el producto ${instance.nombre}`,
        cancel: true,
        persistent: true
      }).onOk(() => {
        // console.log('>>>> OK')
        const url = `http://localhost:5000/api/productos/${instance.id}`
        axios.delete(url).then(res => {
          $q.notify({
            message: 'El producto ha sido Borrado',
            color: 'positive'
          })
          onRequest({
            filter: null
          })
        }).catch(error => {
          $q.notify({
            message: 'El producto No ha sido Borrado',
            color: 'negative'
          })
        })
      }).onOk(() => {
        // console.log('>>>> second OK catcher')
      }).onCancel(() => {
        // console.log('>>>> Cancel')
      }).onDismiss(() => {
        // console.log('I am triggered on both OK and Cancel')
      })
    }

    // Metodos del ciclo de vida del componente
    onMounted(async () => {
      onRequest({
        filter: null
      })

      // Inicializacion de selectores
      const urlListProveedores = 'http://localhost:5000/api/proveedores'
      proveedorList.value = (await axios.get(urlListProveedores, { params: { pagination: false } })).data

      const urlListCategorias = 'http://localhost:5000/api/categorias'
      categoriaList.value = (await axios.get(urlListCategorias, { params: { pagination: false } })).data
      console.log(categoriaList.value)
    })

    // Data
    return {
      columns,
      rows,
      view,
      filter,
      loading,
      producto,
      pagination,
      proveedorList,
      categoriaList,
      grid,
      addProducto,
      onCancel,
      submitProducto,
      editProducto,
      deleteProducto,
      onRequest
    }
  }
}
</script>
